ClassicArmoryLink = {}
ClassicArmoryLinkedPlayers = {}
ClassicArmoryLinkOptions = {}

ClassicArmoryLink.realm = GetRealmName()

REGIONS = {'us', 'kr', 'eu', 'tw', 'cn'}

StaticPopupDialogs["CLICK_LINK_CLICKURL"] = {
    text = "Copy & Paste the armory link into your browser",
    button1 = "Close",
    OnAccept = function()
    end,
    timeout = 0,
    whileDead = true,
    hideOnEscape = true,
    preferredIndex = 3,
    OnShow = function(self, data)
        self.editBox:SetText(data.url)
        self.editBox:HighlightText()
    end,
    hasEditBox = true
}

local function ClassicArmoryLinkButton(contextData)
    print("ClassicArmoryLinkButton")
    local realmSlug = GetRealmName():gsub("[%p%c]", ""):gsub("[%s]", "-"):lower()
    local prefix = "https://atlasforge.gg/wow-classic/armory/"
    local region = REGIONS[GetCurrentRegion()]

    local d = {}
    local url = prefix .. region .. '/' .. realmSlug .. '/' .. contextData.name:lower()
    d.url = url

    StaticPopup_Show("CLICK_LINK_CLICKURL", "", "", d)
end


local menuTags = {
    'MENU_UNIT_SELF',
    -- 'MENU_UNIT_PET',
    -- 'MENU_UNIT_OTHERPET',
    -- 'MENU_UNIT_BATTLEPET',
    -- 'MENU_UNIT_OTHERBATTLEPET',
    'MENU_UNIT_PARTY',
    'MENU_UNIT_PLAYER',
    'MENU_UNIT_ENEMY_PLAYER',
    'MENU_UNIT_RAID_PLAYER',
    'MENU_UNIT_RAID',
    'MENU_UNIT_FRIEND',
    'MENU_UNIT_FRIEND_OFFLINE',
    'MENU_UNIT_BN_FRIEND',
    -- 'MENU_UNIT_BN_FRIEND_OFFLINE',
    -- 'MENU_UNIT_GLUE_FRIEND',
    -- 'MENU_UNIT_GLUE_FRIEND_OFFLINE',
    'MENU_UNIT_GUILD',
    'MENU_UNIT_GUILD_OFFLINE',
    'MENU_UNIT_CHAT_ROSTER',
    -- 'MENU_UNIT_VEHICLE',
    --[[ 'MENU_UNIT_TARGET', ]]
    'MENU_UNIT_ARENAENEMY',
    'MENU_UNIT_FOCUS',
    -- 'MENU_UNIT_BOSS',
    'MENU_UNIT_COMMUNITIES_WOW_MEMBER',
    'MENU_UNIT_COMMUNITIES_GUILD_MEMBER',
    'MENU_UNIT_GUILDS_GUILD',
    'MENU_UNIT_COMMUNITIES_MEMBER',
    'MENU_UNIT_COMMUNITIES_COMMUNITY',
    'MENU_UNIT_RAID_TARGET_ICON',
    'MENU_UNIT_WORLD_STATE_SCORE',
    'MENU_UNIT_PVP_SCOREBOARD',
    -- 'MENU_UNIT_GLUE_PARTY_MEMBER',
}

for _, tag in ipairs(menuTags) do
    Menu.ModifyMenu(tag, function(ownerRegion, rootDescription, contextData)
        rootDescription:CreateDivider()
        rootDescription:CreateButton("\124cfff8b700" .. "Copy Armory Link", function() ClassicArmoryLinkButton(contextData) end)
    end)
end